SystemOrganization addCategory: #BrokenClasses!
SystemOrganization addCategory: #'BrokenClasses-Playground'!
SystemOrganization addCategory: #'BrokenClasses-Biology'!
SystemOrganization addCategory: #'BrokenClasses-PhysicsLibrary'!

Trait named: #FlyingTrait
	uses: {}
	category: 'BrokenClasses-Biology'!

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:01:42.746'!
fly: target
	"Happily flying towards the target"
	self inAir ifFalse: [self liftOff].
	self position: target.
	self inAir ifTrue: [self touchDown].
! !

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:01:55.776'!
liftOff
	"Start flying"
	self inAir: True.! !

!FlyingTrait methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 15:02:07.994'!
touchDown 
	"Stop flying"
	self inAir: False.! !

!TraitExclusion methodsFor: '*BrokenClasses' stamp: 'bf 1/22/2013 16:00:28.641'!
* anArrayOfAssociations 

	TraitCompositionException signal: 'Invalid trait inclusion. You cannot use inclusion and exclusion at the same time.'
! !

ORCmdClassRefactoring subclass: #ORCmdUseMethodsRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:42:12.064'!
currentCompositionString

	^ self currentNode theNonMetaClass traitCompositionString! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:34:31.323'!
filterMethods: methods

	^ methods" select: [:m | m sendsToSuper not]"! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'JS 1/22/2013 13:56:43.649'!
label

	^ 'use foreign methods'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:12:24.447'!
longDescription 

	^ 'Use methods of other classes in this class.'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 18:12:59.383'!
methodLabelsFor: methods

	^ methods collect: [:m | | selfSendVisitor |
		selfSendVisitor := BCSelfSendNodeVisitor new.
		selfSendVisitor visitNode: m parseTree.  
		m sendsToSuper 
			ifTrue: [ 
				m selector asString , ' Warning: sends message to super!!' ] 
			ifFalse: [ | label |
				label := WriteStream with: String new.
				label nextPutAll:  m selector asString.
				selfSendVisitor selfSendSelectors isEmpty ifFalse: [
					label 
						nextPutAll: ' (requires ';
						nextPutAll: ((selfSendVisitor selfSendSelectors) join: ', ');
						nextPutAll: ')' ].
				label contents
				 ]
			]! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:24:20.533'!
methodValuesFor: methods

	^ methods collect: [:m | m selector ]! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:09:11.07'!
promptForeignClass

	^ UIManager default chooseClassOrTrait: 'Choose a class to select methods from'! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:33:52.038'!
promptSelectedMethodsFor: aClass
	
	| methods |
	aClass ifNil: [^ #()].
	methods := self filterMethods: aClass methodDict values.
	^ OBMultipleChoiceRequest 
		prompt: 'Choose methods to include' 
		labels: ( self methodLabelsFor: methods ) 
		values: ( self methodValuesFor: methods )! !

!ORCmdUseMethodsRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:51:55.71'!
refactoring
	| foreignClass methods |
	foreignClass := self promptForeignClass.
	methods := self promptSelectedMethodsFor: foreignClass.
	^ UseMethodClassRefactoring 
		model: self model
		class: self currentNode theNonMetaClass
		oldCompositionString: self currentCompositionString
		foreignClass: foreignClass
		selectedMethods: methods! !

Dictionary subclass: #ClassUsersMap
	instanceVariableNames: ''
	classVariableNames: 'ClassUsers'
	poolDictionaries: ''
	category: 'BrokenClasses'!

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:18'!
at: key ifAbsentPut: aBlock 
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ (ClassUsers at: key ifAbsentPut: aBlock)! !

!ClassUsersMap class methodsFor: 'adding' stamp: 'lmn 1/14/2013 16:12'!
at: key put: aCollection
	ClassUsers ifNil: [ClassUsers := Dictionary new].
	^ ClassUsers at: key put: aCollection! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'bf 1/22/2013 16:03:39.023'!
* anArrayOfSelectors
	"Creates an inclusion"
	^TraitInclusion
		with: self
		inclusions: anArrayOfSelectors! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
+ aTrait
	"Creates a composition with the receiver and aTrait"
	aTrait traitsDo:[:t| self == t ifTrue:[TraitCompositionException
			signal: 'Trait ' , self asString, ' already in composition']].
	^TraitComposition withAll: {self}, aTrait asTraitComposition! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:47'!
- anArrayOfSelectors
	"Creates an exclusion"
	^TraitExclusion
		with: self
		exclusions: anArrayOfSelectors! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:46'!
@ anArrayOfAssociations 
	"Creates an alias"
	^TraitAlias with: self aliases: anArrayOfAssociations! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:30'!
addSelectorSilently: selector withMethod: compiledMethod
	super addSelectorSilently: selector withMethod: compiledMethod.
	self instanceSide noteAddedSelector: selector meta: self isMeta.
	"updateTraits of users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:03'!
addTraitUser: aTrait
	self users: (self users copyWith: aTrait)
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 13:34'!
asTraitComposition
	^TraitComposition with: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:44'!
browserIcon
	"Answer an icon to be show in the browser for the receiving class."

	^ self traitComposition isEmpty ifTrue: [^#blank] ifFalse: [^#announcement]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:31'!
classTrait

	^ ClassTrait for: self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:40'!
copyTraitExpression

	^ self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 15:44:35.75'!
installInstVarsReferredIn: methods

	| allInstVars |
	allInstVars := Set new.
	methods valuesDo: [:method | allInstVars addAll: (method referredInstVars) ].
	allInstVars do: [:var | (self instVarNames includes: var) ifFalse: [
			self addInstVarName: var] ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:59:24.488'!
installTraitsFrom: aTraitComposition
	"Install the traits from the given composition. This method implements
	the core composition method - all others are just optimizations for
	particular cases. Consequently, the optimized versions can always fall
	back to this method when things get too hairy."
	| allTraits methods |

	(self traitComposition isEmpty and: [aTraitComposition isEmpty]) ifTrue: [^self].

	"Check for cycles"
	allTraits := aTraitComposition gather: [:t | t allTraits copyWith: t].
	(allTraits includes: self) ifTrue:[^self error: 'Cyclic trait definition detected'].

	self traitComposition: aTraitComposition.
	methods := self assembleTraitMethodsFrom: aTraitComposition.
	self installInstVarsReferredIn: methods.
	self installTraitMethodDict: methods.
	self isMeta ifFalse:[self classSide updateTraitsFrom: aTraitComposition].
	
	"updateTraits of users"
	self users do: [:each | each updateTraits ].! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:49'!
isTraitTransformation
	"Polymorphic with TraitTransformation"
	^false! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:35:47.178'!
notifyOfRecategorizedSelector: element from: oldCategory to: newCategory
	SystemChangeNotifier uniqueInstance selector: element recategorizedFrom: oldCategory to: newCategory inClass: self.

	"classify:under:from:trait: for all users"
	self users do: [:each | each updateTraits ]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 15:02'!
removeTraitUser: aTrait
	self users: (self users copyWithout: aTrait).
! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 14:30'!
trait
	^self! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 17:37:22.471'!
traitsDo: aBlock
	aBlock value: self.! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/14/2013 16:21'!
users

	^ ClassUsersMap at: (self name asSymbol) ifAbsentPut: [^ #()]! !

!ClassDescription methodsFor: '*BrokenClasses' stamp: 'lmn 1/15/2013 14:36:00.746'!
users: aCollection

	^ ClassUsersMap at: (self name asSymbol) put: aCollection! !

ClassRefactoring subclass: #UseMethodClassRefactoring
	instanceVariableNames: 'oldCompositionString foreignClass selectedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!UseMethodClassRefactoring class methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 15:48:10.932'!
model: aModel class: aClass oldCompositionString: compositionString foreignClass: aForeignClass selectedMethods: anArray

	^ (self
		model: aModel
		className: aClass name)
		oldCompositionString: compositionString;
		foreignClass: aForeignClass;
		selectedMethods: anArray;
		yourself  ! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:07:05.214'!
categoryName

	^ self targetClass category asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:12.098'!
classVariableNames

	^ self targetClass classVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:46:39.884'!
foreignClass
	^foreignClass! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 15:46:52.037'!
foreignClass: aClass
	foreignClass := aClass! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:26:29.252'!
initialize 

	traitCompositionString := '#()'! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:13:04.986'!
instanceVariableNames

	^ self targetClass instanceVariableNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:58:14.686'!
oldCompositionString
	^oldCompositionString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:58:28.026'!
oldCompositionString: aString
	oldCompositionString := aString.! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:12:42.389'!
poolDictionaries

	^ self targetClass poolDictionaryNames join: ' '! !

!UseMethodClassRefactoring methodsFor: 'preconditions' stamp: 'lmn 1/22/2013 16:07:47.552'!
preconditions
	| class fClass |
	class := self targetClass.
	fClass := self foreignClass.
	^ (RBCondition withBlock: [class notNil and: [class isMeta not]]
		errorString: class name, ' is not a valid composit class') &
		(RBCondition withBlock: [ fClass notNil ] errorString: 'Must select a foreign class.' )! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:26.232'!
redefineClassString

	^ self targetSuperclassName, ' subclass: #', className , ' uses: ', self traitCompositionString , ' instanceVariableNames: ''', self instanceVariableNames ,''' classVariableNames:''',self classVariableNames,''' poolDictionaries:''',self poolDictionaries,''' category: ''',self categoryName,''' '! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/22/2013 16:39:10.019'!
selectedMethods

	^ selectedMethods! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'JS 1/16/2013 11:24:12.666'!
selectedMethods: anArray
	selectedMethods := anArray! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 16:39:06.853'!
targetClass

	^ self model classNamed: className! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'lmn 1/15/2013 17:08:21.306'!
targetSuperclassName

	^ self targetClass superclass name asString! !

!UseMethodClassRefactoring methodsFor: 'accessing' stamp: 'bf 1/23/2013 03:38:17.397'!
traitCompositionString
|prefix methodsString|
	(self oldCompositionString = '{}')
		ifTrue: [ prefix := '']
		ifFalse: [ prefix := self oldCompositionString, ' + '].

	(selectedMethods size > 0)
		ifTrue: [methodsString := '*{', ((selectedMethods collect: [:m | '#', m asString]) join: '. '),'}']
		ifFalse: [methodsString := ''].

"Old version based on blacklisting (rejection):"
"	methods := self foreignClass methodDict keys reject: [:k | self selectedMethods includes: k].
	(methods size > 0)
		ifTrue: [methodsString := '-{', ((methods collect: [:m | '#', m asString]) join: '. '),'}']
		ifFalse: [methodsString := '']."
		
	^prefix, (self foreignClass name), methodsString! !

!UseMethodClassRefactoring methodsFor: 'transforming' stamp: 'lmn 1/15/2013 17:25:16.831'!
transform

	self model defineClass: self redefineClassString! !

!TraitComposition methodsFor: '*BrokenClasses' stamp: 'bf 1/23/2013 03:01:33.641'!
* anArray
	"the modifier operators #@, #- and #* bind stronger than +.
	Thus, #@, #- and #* sent to a sum will only affect the most right summand"
	
	self addLast: (self removeLast * anArray)! !

Object subclass: #BaseTrait
	instanceVariableNames: 'baseVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 18:13:28.283'!
fastforward

	self rewind.
	^ self! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 15:05:24.449'!
play

	baseVar := 42.
	^ 2! !

!BaseTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:15:30.093'!
rewind

	^ self! !

BaseTrait subclass: #SpecialTrait
	instanceVariableNames: 'specialVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!SpecialTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 14:29:10.864'!
play

	^ super play + 4! !

Object subclass: #Creature
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Creature methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:16:24.897'!
position
	^ position! !

!Creature methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:16:24.925'!
position: anObject
	position := anObject! !

Creature subclass: #Insect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Insect subclass: #Ant
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Ant methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:31:56.41'!
crawl: target
	"Happily crawling towards the target."
	self position: target.! !

Insect subclass: #Fly
	uses: FlyingTrait
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Fly class
	uses: FlyingTrait classTrait
	instanceVariableNames: ''!

!Fly methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:37:47.006'!
inAir
	^ inAir! !

!Fly methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:37:47.035'!
inAir: anObject
	inAir := anObject! !

Creature subclass: #Mammal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Mammal subclass: #Bat
	uses: FlyingTrait
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

Bat class
	uses: FlyingTrait classTrait
	instanceVariableNames: ''!

!Bat methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:38:01.702'!
inAir
	^ inAir! !

!Bat methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:38:01.73'!
inAir: anObject
	inAir := anObject! !

Mammal subclass: #Dolphin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Biology'!

!Dolphin methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:31:45.692'!
swim: target
	"Happily swimming towards the target."

	self position: target.! !

Object subclass: #MovingEntity
	instanceVariableNames: 'position speed acceleration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-PhysicsLibrary'!

MovingEntity subclass: #FlyingEntity
	instanceVariableNames: 'inAir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-PhysicsLibrary'!

!FlyingEntity methodsFor: 'as yet unclassified' stamp: 'bf 1/23/2013 15:04:19.163'!
accelerate
	"Fly faster"
	self acceleration: self acceleration +1.! !

!FlyingEntity methodsFor: 'as yet unclassified' stamp: 'bf 1/23/2013 15:02:55.962'!
fly: direction
	"Fly somewhere"
	self inAir ifFalse: [self liftOff].

	"TODO: Update position, speed and acceleration continuously according to the object's flying properties."
	self position: direction.

	self inAir ifTrue: [self touchDown].
! !

!FlyingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:45:14.934'!
inAir
	^ inAir! !

!FlyingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:45:14.963'!
inAir: anObject
	inAir := anObject! !

!FlyingEntity methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:45:35.339'!
liftOff
	"Start flying"
	self inAir: True.! !

!FlyingEntity methodsFor: 'as yet unclassified' stamp: 'bf 1/23/2013 15:05:00.831'!
slowDown
	"Fly slower"
	self acceleration: self acceleration - 1.! !

!FlyingEntity methodsFor: 'as yet unclassified' stamp: 'bf 1/22/2013 14:45:47.926'!
touchDown 
	"Stop flying"
	self inAir: False.! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:36.167'!
acceleration
	^ acceleration! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:36.195'!
acceleration: anObject
	acceleration := anObject! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:56.486'!
position
	^ position! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:40:56.515'!
position: anObject
	position := anObject! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:41:18.458'!
speed
	^ speed! !

!MovingEntity methodsFor: 'accessing' stamp: 'bf 1/22/2013 14:41:18.488'!
speed: anObject
	speed := anObject! !

Object subclass: #OtherTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

!OtherTrait methodsFor: 'as yet unclassified' stamp: 'lmn 1/15/2013 17:36:01.272'!
drive

	^ self! !

!OtherTrait methodsFor: 'as yet unclassified' stamp: 'JS 1/16/2013 11:50:09.079'!
navigate

	^ self! !

Object subclass: #TraitUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses-Playground'!

RBProgramNodeVisitor subclass: #BCSelfSendNodeVisitor
	instanceVariableNames: 'selfSendSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!BCSelfSendNodeVisitor methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 17:47:34.794'!
acceptMessageNode: aMessageNode 
	
	super acceptMessageNode: aMessageNode.
	aMessageNode isSelfSend ifTrue: [
		self selfSendSelectors add: aMessageNode selector ]! !

!BCSelfSendNodeVisitor methodsFor: 'as yet unclassified' stamp: 'lmn 1/22/2013 17:46:52.917'!
initialize

	selfSendSelectors := OrderedCollection new.! !

!BCSelfSendNodeVisitor methodsFor: 'accessing' stamp: 'lmn 1/22/2013 17:47:07.239'!
selfSendSelectors
	^ selfSendSelectors! !

!TraitAlias methodsFor: '*BrokenClasses' stamp: 'bf 1/22/2013 15:59:29.004'!
* anArrayOfSelectors
	^TraitInclusion
		with: self
		inclusions: anArrayOfSelectors! !

TraitTransformation subclass: #TraitInclusion
	instanceVariableNames: 'inclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BrokenClasses'!

!TraitInclusion class methodsFor: 'instance creation' stamp: 'bf 1/22/2013 15:51:55.385'!
with: aTraitComposition inclusions: anArrayOfSelectors
	^self new
		subject: aTraitComposition;
		inclusions: anArrayOfSelectors;
		yourself
! !

!TraitInclusion methodsFor: 'converting' stamp: 'bf 1/23/2013 03:05:49.823'!
* anArrayOfSelectors
	^TraitInclusion 
		with: subject
		inclusions: (anArrayOfSelectors, inclusions asArray)! !

!TraitInclusion methodsFor: 'converting' stamp: 'bf 1/22/2013 15:58:50.5'!
- anArrayOfAssociations 

	TraitCompositionException signal: 'Invalid trait inclusion. You cannot use inclusion and exclusion at the same time.'
! !

!TraitInclusion methodsFor: 'converting' stamp: 'bf 1/22/2013 15:58:07.231'!
@ anArrayOfAssociations 

	TraitCompositionException signal: 'Invalid trait inclusion. Aliases have to be specified before inclusions.'
! !

!TraitInclusion methodsFor: 'composition' stamp: 'bf 1/22/2013 16:05:38.69'!
copyTraitExpression
	"Copy all except the actual traits"
	^TraitInclusion 
		with: subject
		inclusions: inclusions asArray! !

!TraitInclusion methodsFor: 'composition' stamp: 'bf 1/22/2013 15:56:27.665'!
includesSelector: selector
	"Answers true if the receiver provides the selector"
	^(subject includesSelector: selector) and:[(inclusions includes: selector) not]! !

!TraitInclusion methodsFor: 'accessing' stamp: 'bf 1/22/2013 15:52:14.729'!
inclusions
	^ inclusions! !

!TraitInclusion methodsFor: 'accessing' stamp: 'bf 1/22/2013 15:52:14.784'!
inclusions: anObject
	inclusions := anObject! !

!TraitInclusion methodsFor: 'initialize' stamp: 'bf 1/22/2013 15:56:40.976'!
initialize
	super initialize.
	inclusions := Set new.
! !

!TraitInclusion methodsFor: 'composition' stamp: 'bf 1/22/2013 15:56:59.92'!
printOn: aStream
	"Answer the trait composition string (used for class definitions)"
	aStream nextPutAll: subject asString.
	aStream nextPutAll: ' * {'.
	inclusions asArray sort do:[:exc| aStream store: exc] separatedBy:[aStream nextPutAll: '. '].
	aStream nextPutAll: '}'.! !

!TraitInclusion methodsFor: 'composition' stamp: 'bf 1/22/2013 15:57:31.841'!
selectorsAndMethodsDo: aBlock
	"enumerates all selectors and methods in a trait composition"
	^subject selectorsAndMethodsDo:[:sel :meth|
		(inclusions includes: sel) ifTrue: [aBlock value: sel value: meth].
	].! !

!TraitTransformation methodsFor: '*BrokenClasses' stamp: 'bf 1/22/2013 15:59:45.879'!
* anArrayOfSelectors
	^self subclassResponsibility! !

!TraitDescription methodsFor: '*BrokenClasses' stamp: 'bf 1/22/2013 16:02:18.96'!
* anArrayOfSelectors
	"Creates an inclusion"
	^TraitInclusion
		with: self
		inclusions: anArrayOfSelectors! !
